%define uname sendmailanalyzer
%define webdir %{_localstatedir}/www/%{uname}
%define rundir %{_localstatedir}/run
%define _unpackaged_files_terminate_build 0

Name: %{uname}
Epoch: 0
Version: 9.0
Release: 9%{?dist}
Summary: Sendmail/Postfix log analyser with graphical reports, modified for BlueOnyx 520XR.

Group: System Environment/Daemons
License: GPLv3+
URL: http://sareport.darold.net/
Source0: http://downloads.sourceforge.net/%{name}/%{uname}-%{version}.tar.gz
BuildArch: noarch
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

Requires: libpng
Requires: gd
Requires: httpd
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
#Requires: vixie-cron
Requires: perl-JSON

%description
%{uname} continuously read your mail log file to generate
periodical HTML and graph reports. All reports are shown throught
a CGI web interface. It reports all you ever wanted to know about
email trafic on your network. You can also use it in ISP environment
with per domain report.

%prep
%setup -q -n %{uname}-%{version}

# create default crontab entry
%{__cat} > %{uname}.cron << _EOF1_
# Sendmail log reporting daily cache
0 1 * * *     root  %{_bindir}/sa_cache > /dev/null 2>&1
# Daemon restart after maillog logrotate (cron jobs at 4:04 every day)
# Feel free to replace this line by an entry in /etc/logrotate.d/syslog
4 4 * * *     root  /etc/rc.d/init.d/sendmailanalyzer restart > /dev/null 2>&1
# On huge MTA you may want to have five minutes caching
*/5 * * * *   root  %{_bindir}/sa_cache -a > /dev/null 2>&1

_EOF1_

# create default httpd configuration
%{__cat} > httpd-%{uname}.conf << _EOF2_
#
# By default %{uname} statistics are only accessible via the BlueOnyx 520XR GUI.
# That is the reason the below config is entirely commented out. DO NOT CHANGE THAT!
# 
#Alias /sareport %{webdir}
#
#<Directory %{webdir}>
#    Options ExecCGI
#    AddHandler cgi-script .cgi
#    DirectoryIndex sa_report.cgi
#    Order deny,allow
#    Deny from all
#    Allow from 127.0.0.1
#    Allow from ::1
#    # Allow from .example.com
#</Directory>

_EOF2_

# create README.RPM
%{__cat} > README.RPM << _EOF3_

1. Start $PNAME daemon with: /etc/rc.d/init.d/sendmailanalyzer start
   or /sbin/service sendmailanalyzer start

2. Uncomment the entries in %{_sysconfdir}/httpd/conf.d/%{uname}.conf.

3. Restart and ensure that httpd is running.

4. Browse to http://localhost/sareport/ to ensure that things are working
   properly.

5. If necessary, give additional hosts access to %{uname} by adding them to
   %{_sysconfdir}/httpd/conf.d/%{uname}.conf.

6. Setup a cronjob to run sa_cache and restart %{uname} daemon after maillog
   logrotate. Uncomment the entries in %{_sysconfdir}/cron.d/%{uname} or
   create a custom cronjob.

_EOF3_

%build
# Make Perl and SendmailAnalyzer distrib files
%{__perl} Makefile.PL \
    INSTALLDIRS=vendor \
    QUIET=1 \
    LOGFILE=/var/log/maillog \
    BINDIR=%{_bindir} \
    CONFDIR=%{_sysconfdir} \
    PIDDIR=%{rundir} \
    BASEDIR=/home/.sendmailanalyzer \
    HTMLDIR=%{webdir} \
    MANDIR=%{_mandir}/man3 \
    DOCDIR=%{_docdir}/%{uname}-%{version} \
    DESTDIR=%{buildroot} < /dev/null
%{__make}

#    BASEDIR=%{_localstatedir}/lib/%{uname} \


# nope, gotta love perl

%install
%{__rm} -rf %{buildroot}
# set up path structure
%{__install} -d -m 0755 %{buildroot}/%{_bindir}
%{__install} -d -m 0755 %{buildroot}/%{_sysconfdir}
%{__install} -d -m 0755 %{buildroot}/%{_localstatedir}/lib/%{uname}
%{__install} -d -m 0755 %{buildroot}/home/.sendmailanalyzer
%{__install} -d -m 0755 %{buildroot}/%{_localstatedir}/run
%{__install} -d -m 0755 %{buildroot}/%{webdir}
%{__install} -d -m 0755 %{buildroot}/%{webdir}/lang
%{__install} -d -m 0755 %{buildroot}/usr/lib/systemd/system

# Make distrib files
%{__make} install \
    DESTDIR=%{buildroot}

# Remove empty perl directory
%{__rm} -rf %{buildroot}/usr/lib

# Remove unnecessary Perl build artifacts
%{__rm} -f %{buildroot}/usr/lib64/perl5/perllocal.pod
%{__rm} -rf %{buildroot}/usr/lib64/perl5/vendor_perl/auto/sendmailanalyzer

%{__install} -D -m 0644 %{uname}.cron \
    %{buildroot}/%{_sysconfdir}/cron.d/%{uname}
#%{__install} -D -m 0644 httpd-%{uname}.conf %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{uname}.conf
%{__install} -D -m 0644 doc/%{uname}.3 \
    %{buildroot}/%{_mandir}/man3/%{uname}.3
%{__install} -D -m 0644 doc/sa_cache.3 \
    %{buildroot}/%{_mandir}/man3/sa_cache.3
%{__install} -D -m 0644 salogo.png \
    %{buildroot}/%{webdir}/salogo.png
%{__install} -D -m 0644 flotr2.js \
    %{buildroot}/%{webdir}/flotr2.js
%{__install} -Dpm 0755 start_scripts/sendmailanalyzer %{buildroot}%{_sysconfdir}/rc.d/init.d/sendmailanalyzer
%{__install} -Dpm 0644 start_scripts/sendmailanalyzer.service %{buildroot}/usr/lib/systemd/system/sendmailanalyzer.service
%{__install} -Dpm 0755 sa_to_php.pl %{buildroot}/%{_localstatedir}/lib/%{uname}/sa_to_php.pl
%{__install} -Dpm 0755 sa_to_php.pl %{buildroot}/home/.sendmailanalyzer/sa_to_php.pl
%{__install} -D -m 0644 sa_to_php.xml %{buildroot}/%{_sysconfdir}/ccewrap.d/sa_to_php.xml

%clean
%{__rm} -rf %{buildroot}

%post
if [ $1 -eq 1 ]; then
    if [ -f /usr/bin/systemctl ];then
	/usr/bin/systemctl daemon-reload &>/dev/null || :
	/usr/bin/systemctl enable sendmailanalyzer.service &>/dev/null || :
	/usr/bin/systemctl restart sendmailanalyzer.service  &>/dev/null || :
    else
	/sbin/chkconfig --add sendmailanalyzer
	/sbin/service sendmailanalyzer restart &>/dev/null || :
    fi
fi

if [ $1 -eq 2 ]; then
	if [ -f /usr/bin/systemctl ];then
		/usr/bin/systemctl daemon-reload &>/dev/null || :
		/usr/bin/systemctl restart sendmailanalyzer.service  &>/dev/null || :
	else
		/sbin/service sendmailanalyzer restart &>/dev/null || :
	fi
fi

%pre
if [ -d /var/lib/sendmailanalyzer ]; then
	if [ ! -d /home/.sendmailanalyzer ]; then
		mkdir /home/.sendmailanalyzer
		mv -f /var/lib/sendmailanalyzer/* /home/.sendmailanalyzer/
	fi
fi

%preun
if [ $1 -eq 0 ]; then
    if [ -f /usr/bin/systemctl ];then
        /usr/bin/systemctl stop sendmailanalyzer.service  &>/dev/null || :
        /usr/bin/systemctl disable sendmailanalyzer.service &>/dev/null || :
        /usr/bin/systemctl daemon-reload &>/dev/null || :
    else
        /sbin/service sendmailanalyzer stop &>/dev/null || :
        /sbin/chkconfig --del sendmailanalyzer
    fi
fi

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/ChangeLog
%doc %{_docdir}/%{name}-%{version}/INSTALL
%doc %{_docdir}/%{name}-%{version}/README
%doc %{_docdir}/%{name}-%{version}/sendmailanalyzer.conf.sample
%attr(0755,root,root) %{_bindir}/%{uname}
%attr(0755,root,root) %{_bindir}/sa_cache
%attr(0644,root,root) %{_mandir}/man3/%{uname}.3.gz
%attr(0644,root,root) %{_mandir}/man3/sa_cache.3.gz
%attr(0644,root,root) %{webdir}/salogo.png
%attr(0755,root,root) %{webdir}/sa_report.cgi
%attr(0644,root,root) %{webdir}/flotr2.js
%attr(0644,root,root) %{webdir}/lang/ERROR_CODE
%attr(0644,root,root) %{webdir}/lang/en_US
%attr(0644,root,root) %{webdir}/lang/fr_FR
%attr(0644,root,root) %{webdir}/lang/sp_SP
%attr(0644,root,root) %{webdir}/lang/bg_BG
%attr(0644,root,root) %{webdir}/lang/de_DE
%attr(0644,root,root) %{webdir}/lang/pt_BR
%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/sendmailanalyzer
%attr(0644,root,root) /usr/lib/systemd/system/sendmailanalyzer.service
%config(noreplace) %{_sysconfdir}/%{uname}.conf
%config(noreplace) %{_sysconfdir}/cron.d/%{uname}
#%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{uname}.conf
%dir /home/.sendmailanalyzer
#%dir %{_localstatedir}/lib/%{uname}
%dir %{_localstatedir}/run
%dir %{webdir}
%attr(0755,root,root) %{_localstatedir}/lib/%{uname}/sa_to_php.pl
%attr(0755,root,root) /home/.sendmailanalyzer/sa_to_php.pl
%config(noreplace) %{_sysconfdir}/ccewrap.d/sa_to_php.xml
%attr(0644,root,root) /usr/share/perl5/vendor_perl/sa_to_php.pl

%changelog

* Fri Jun 20 2025 Michael Stauber <mstauber@solarspeed.net>
- [9.0-9] Rebuilt for 5212R

* Mon Mar 09 2015 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX07]: Moved /var/lib/sendmailanalazer to new location
  /home/.sendmailanalyzer, but kept the skelleton of it for
  compatability with the GUI.
- Added pre-install script for migration of the data.

* Sun Jan 25 2015 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX07]: Modified build for BlueOnyx 5209R.
- Fixed Systemd Unit file for 5209R on EL7.

* Sat Dec 20 2014 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX06]: Modified build for BlueOnyx 5209R.
- Added Systemd Unit file for 5209R on EL7.

* Thu Jun 26 2014 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX05]: Modified build for BlueOnyx 520XR.
- Modified sa_cache regexp again. That should do it.

* Thu Jun 26 2014 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX04]: Modified build for BlueOnyx 520XR.
- Added /etc/ccewrap.d/sa_to_php.xml

* Thu Jun 26 2014 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX03]: Modified build for BlueOnyx 520XR.
- Modified sa_cache with a better regexp to escape things that
  break our hash delimiters.

* Wed Jun 25 2014 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX02]: Modified build for BlueOnyx 520XR.
- Added requirement for perl-JSON as sa_to_php.pl needs it.

* Wed Jun 25 2014 Michael Stauber <mstauber@solarspeed.net>
- [9.0-2BX01]: Modified build for BlueOnyx 520XR.
- Modified sendmailanalyzer to replace a few things in the cache.pm files.
- CCE-aware sa_cache to automatically poll email server aliases of Vsites.
- Added Perl to PHP wrapper /var/lib/sendmailanalyzer/sa_to_php.pl
- Activated cronjobs by default.
- Automatically start sendmailanalyzer on RPM install.
- Removed Apache config as we most surely do NOT want it on the public Apache.

* Mon Dec 23 2013 Igor Vuk
- Remove a rogue tab character, add pt_BR translation

* Tue May 07 2013 Gilles Darold
- Upgrade for 9.0 changes

* Sun Jan 06 2013 Gilles Darold
- Add man page for sa_cache.

* Mon Dec 31 2012 Igor Vuk
- Fix the .sample file install in doc folder.

* Mon Dec 24 2012 Gilles Darold
- Copy sendmailanalyzer.conf in _sysconfdir and sendmailanalyzer.conf.sample
  in _docdir

* Wed Dec 19 2012 Igor Vuk
- Update change of sendmailanalyzer.conf in sendmailanalyzer.conf.sample

* Wed Jan 20 2010 Gilles Darold <gilles@darold.net>
- Fix overide of http-sendmailanalyzer.conf

* Wed Dec 30 2009 Gilles Darold <gilles@darold.net>
- first packaging attempt

